 #include <IRremote.h>      //biblioteka odpowiedzialna za obsługe odbiornika TSOP2236 
#define irPin 3            //wskazanie pinu pod który podłłączony jest odbiornik Ir
IRrecv irrecv(irPin);
decode_results results;
#include <LiquidCrystal.h>    //biblioteka odpowiedzialna za obsługe wyświetlacza LCD
LiquidCrystal lcd(8, 9, 10, 11, 12, 13);      //wskazanie pinów pod które podłączony jest wyświetlacz odpowiednio RS, ENABLE, D4, D5, D6, D7
#define podswietlanie 7     //zdefiniowanie nazwy i numeru pinu gdzie podłączona jest dioda LED odpowiedzialna za podświetlanie wyświetlacza
#include <Wire.h>
#include "RTClib.h"      //biblioteki odpowiedzialne za obsługe modułu RTC DS1307       
RTC_DS1307 rtc;
#include <PCF8574.h>    //bibloteka odpowiedzialna za obsługe ekspandera PCF8574
#define pstryk 6       //zdefiniowanie nazwy i numeru pinu gdzie podłączony jest przełącznik

PCF8574 expander;

#include <EEPROM.h>    //biblioteka odpowiedzialna za obsługe pamięci nieulotnej EEPROM

int m = 1;
int p;
int h_zad_ods;
int m_zad_ods;
int h_zad_zas;
int m_zad_zas;
int h_zad_ods_w;
int m_zad_ods_w;
int a;
int b;
int c;
int d;
int e;
int f;
int zi=0;
int godzina = 0;
int minuta = 0;
int sekunda = 0;
int dzien = 1;
int miesiac = 1;
int rok = 2015;
int r1;
int r2;
int dzien_tyg;
int dzien_tyg_1;
int z;
int k;
int pom = 1;
int help = 1;

unsigned long czas2;
unsigned int czas_led = 20000;

String ok;
String wstecz;
String gora1;
String dol1;
String prawo;
String lewo;
String kod;

 
void setup() {
  pinMode(podswietlanie,OUTPUT);
  pinMode(pstryk,INPUT_PULLUP);
   digitalWrite(podswietlanie, HIGH);
   Serial.begin(9600);
   irrecv.enableIRIn();
   lcd.begin(16,2);
   Wire.begin();
   rtc.begin();
   
   
  expander.begin(0x20);
  expander.pinMode(0, INPUT);
  expander.pinMode(1, INPUT);
  expander.pinMode(2, INPUT);
  expander.pinMode(3, INPUT);
  expander.pinMode(4, OUTPUT);
  expander.pinMode(5, OUTPUT);
  expander.pinMode(6, OUTPUT);
  expander.pinMode(7, OUTPUT);
  expander.pullUp(0);
  expander.pullUp(1);
  expander.pullUp(2);
  expander.pullUp(3);
   
   
    if (! rtc.isrunning()) {
    rtc.adjust(DateTime(rok, miesiac, dzien, godzina, minuta, sekunda));
    zi=1;
  }
   
   h_zad_ods=EEPROM.read(0);
   m_zad_ods=EEPROM.read(1);
   h_zad_zas=EEPROM.read(2);
   m_zad_zas=EEPROM.read(3);
   h_zad_ods_w=EEPROM.read(4);
   m_zad_ods_w=EEPROM.read(5);
   
   
   lcd.setCursor(2, 0);
   lcd.print("I");
   delay(100);
   lcd.print("N");
   delay(100);
   lcd.print("T");
   delay(100);
   lcd.print("E");
   delay(80);
   lcd.print("L");
   delay(100);
   lcd.print("I");
   delay(100);
   lcd.print("G");
   delay(100);
   lcd.print("E");
   delay(100);
   lcd.print("N");
   delay(100);
   lcd.print("T");
   delay(100);
   lcd.print("N");
   delay(100);
   lcd.print("E");
   delay(100);

   lcd.setCursor(5, 1);
   lcd.print("R");
   delay(100);
   lcd.print("O");
   delay(100);
   lcd.print("L");
   delay(100);
   lcd.print("E");
   delay(100);
   lcd.print("T");
   delay(100);
   lcd.print("Y");
   delay(100);
   
   delay(3000);
   lcd.clear();
   digitalWrite(podswietlanie, LOW);
}

  void kody1(){
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Nacisnij 'OK'");
    if (irrecv.decode(&results)){
    ok = results.value;
    irrecv.resume();
    m=12;
    delay(1000);
    irrecv.resume();
    }
    delay(50);
      }
      
    void kody2(){
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Nacisnij'WSTECZ'");
    if (irrecv.decode(&results)){
    wstecz = results.value;
    irrecv.resume();
    m=13;
    delay(1000);
    irrecv.resume();
    }
    delay(50);
      }

    void kody3(){
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Nacisnij 'GORA'");
    if (irrecv.decode(&results)){
    gora1 = results.value;
    irrecv.resume();
    m=14;
    delay(1000);
    irrecv.resume();
    }
    delay(50);
      }

    void kody4(){
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Nacisnij 'DOL'");
    if (irrecv.decode(&results)){
    dol1 = results.value;
    irrecv.resume();
    delay(1000);
    m=15;
    irrecv.resume();
    }
    delay(50);
      }

    void kody5(){
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Nacisnij 'PRAWO'");
    if (irrecv.decode(&results)){
    prawo = results.value;
    irrecv.resume();
    m=16;
    delay(1000);
    irrecv.resume();
    }
    delay(50);
      }

    void kody6(){
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Nacisnij 'LEWO'");
    if (irrecv.decode(&results)){
    lewo = results.value;
    irrecv.resume();
    delay(1000);
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Pilot dodany");
    lcd.setCursor(4, 1);
    lcd.print("pomyslnie!");
    delay(2000);
    lcd.clear();
    m=1;
    irrecv.resume();
    }
    delay(50);
      }

  void glowna(){
     if ( rtc.isrunning()) {
     lcd.clear();
     lcd.setCursor(0, 1);
     if(dzien_tyg == 0){lcd.print("ni");}
     if(dzien_tyg == 1){lcd.print("po");}
     if(dzien_tyg == 2){lcd.print("wt");}
     if(dzien_tyg == 3){lcd.print("sr");}
     if(dzien_tyg == 4){lcd.print("cz");}
     if(dzien_tyg == 5){lcd.print("pt");}
     if(dzien_tyg == 6){lcd.print("so");}
     lcd.setCursor(3, 1);
     if(d<10){lcd.print("0");}
     lcd.print(d);
     lcd.print('/');
     if(e<10){lcd.print("0");}
     lcd.print(e);
     lcd.print('/');
     lcd.print(f);
     lcd.setCursor(4, 0);
     if(a<10){lcd.print("0");}
     lcd.print(a);
     lcd.print(":");
     if(b<10){lcd.print("0");}
     lcd.print(b);
     lcd.print(":");
     if(c<10){lcd.print("0");}
     lcd.print(c);
     lcd.setCursor(14, 1);
     if(zi==1){lcd.print("**");}
     if(millis() >= czas2 + czas_led){digitalWrite(podswietlanie,LOW);}
       delay(50);
     }
     else{
       digitalWrite(podswietlanie, HIGH);
       lcd.setCursor(0,0);
       lcd.print("Awaria!");
     }

     if(digitalRead(pstryk) == LOW){
    digitalWrite(podswietlanie, HIGH);
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Odczyt");
    lcd.setCursor(4, 1);
    lcd.print("pilota");
    delay(2000);
    m=11;
    }
     
     if (irrecv.decode(&results)) {
      kod = results.value;


      if(kod == wstecz){
        digitalWrite(podswietlanie,HIGH);
        czas2 = millis();
        }
      
      if(kod == ok){m=2; delay(200); lcd.clear();}
      
      if(kod == gora1){
           r1=2;
           expander.digitalWrite(6,LOW); 
           expander.digitalWrite(7,HIGH);
        }

        if(kod == dol1){
           r1=1;
           expander.digitalWrite(6,HIGH); 
           expander.digitalWrite(7,LOW);
        }

         if(kod == prawo){
               r2=2;
               expander.digitalWrite(4,LOW); 
               expander.digitalWrite(5,HIGH);
        }

          if(kod == lewo){
               r2=1;
               expander.digitalWrite(4,HIGH); 
               expander.digitalWrite(5,LOW);
        }
       irrecv.resume();
       kod="";
     }
     
  }
  
  void menu(){
    lcd.setCursor(1,0);
    lcd.print("Ust.rolet");
    lcd.setCursor(1,1);
    lcd.print("Ust.czasu");
    if(pom==1){lcd.setCursor(0,0); lcd.print(">");}
    if(pom==2){lcd.setCursor(0,1); lcd.print(">");}
    
    if (irrecv.decode(&results)) { 
       kod = results.value;


       if(kod == wstecz){m=1; czas2 = millis();}

       if(kod == ok){
            if(pom==1){m=3;}
            if(pom==2){m=4;}
            pom=1;
            lcd.clear();
        }

       if(kod == gora1){
            pom++;
            if(pom>2){pom=1;}
            lcd.clear();
       }

           if(kod == dol1){
            pom--;
            if(pom<1){pom=2;}
            lcd.clear();
       }
       irrecv.resume();
       kod="";
    }
      
  }
  
  void ust_rol(){
    lcd.setCursor(1,0);
    lcd.print("Godz.odsuniecia");
    lcd.setCursor(1,1);
    lcd.print("Godz.zasuniecia");
    if(pom==1){lcd.setCursor(0,0); lcd.print(">");}
    if(pom==2){lcd.setCursor(0,1); lcd.print(">");}

       if (irrecv.decode(&results)) { 
       kod = results.value;


       if(kod == wstecz){m=1; czas2 = millis();}

       if(kod == ok){
            if(pom==1){m=9;}
            if(pom==2){m=6;}
            pom=1;
            lcd.clear();
        }

       if(kod == gora1){
            pom++;
            if(pom>2){pom=1;}
            lcd.clear();
       }

           if(kod == dol1){
            pom--;
            if(pom<1){pom=2;}
            lcd.clear();
       }
       irrecv.resume();
       kod="";
    }
  }
  
  
  
  
  void ust_tydz(){
    lcd.setCursor(1,0);
    lcd.print("Tydzien");
    lcd.setCursor(1,1);
    lcd.print("Weekend");
    if(pom==1){lcd.setCursor(0,0); lcd.print(">");}
    if(pom==2){lcd.setCursor(0,1); lcd.print(">");}

       if (irrecv.decode(&results)) { 
       kod = results.value;


       if(kod == wstecz){m=1; czas2 = millis();}

       if(kod == ok){
            if(pom==1){m=5;}
            if(pom==2){m=10;}
            pom=1;
            lcd.clear();
        }

       if(kod == gora1){
            pom++;
            if(pom>2){pom=1;}
            lcd.clear();
       }

           if(kod == dol1){
            pom--;
            if(pom<1){pom=2;}
            lcd.clear();
       }
       irrecv.resume();
       kod="";
    }
  }
  
  
  void rol_ods_w(){
    lcd.setCursor(0,0);
    lcd.print("Godz.ods weekend");
    lcd.setCursor(5,1);
    if(h_zad_ods_w<10){lcd.print("0");}
    lcd.print(h_zad_ods_w);
    lcd.print(":");
    if(m_zad_ods_w<10){lcd.print("0");}
    lcd.print(m_zad_ods_w);
    if(help==1){lcd.setCursor(4,1); lcd.print(">"); }
    if(help==2){lcd.setCursor(10,1); lcd.print("<");}

 if (irrecv.decode(&results)) { 
       kod = results.value;


       if(kod == ok){
            lcd.clear();
            lcd.setCursor(4,0);
            lcd.print("Zapisano!");
            delay(2000);
            m=1;
            czas2 = millis();
        }

if(help == 1){
        if(kod == gora1){
            h_zad_ods_w++;
            if(h_zad_ods_w>23){h_zad_ods_w=0;}
            EEPROM.write(4, h_zad_ods_w);
            lcd.clear();
        }

            if(kod == dol1){
            h_zad_ods_w--;
            if(h_zad_ods_w<0){h_zad_ods_w=23;}
            EEPROM.write(4, h_zad_ods_w);
            lcd.clear();
        }
}

if(help == 2){
        if(kod == gora1){
            m_zad_ods_w++;
            if(m_zad_ods_w>59){m_zad_ods_w=0;}
            EEPROM.write(5, m_zad_ods_w);
            lcd.clear();
        }

            if(kod == dol1){
            m_zad_ods_w--;
            if(m_zad_ods_w<0){m_zad_ods_w=59;}
            EEPROM.write(5, m_zad_ods_w);
            lcd.clear();
        }
}  

           if(kod == prawo){
            help++;
            if(help>2){help=1;}
            lcd.clear();
       }

           if(kod == lewo){
            help--;
            if(help<1){help=2;}
            lcd.clear();
       }
       irrecv.resume();
       kod="";
 }
  }
  
  

  void rol_ods(){
    lcd.setCursor(0,0);
    lcd.print("Godz.odsuniecia");
    lcd.setCursor(5,1);
    if(h_zad_ods<10){lcd.print("0");}
    lcd.print(h_zad_ods);
    lcd.print(":");
    if(m_zad_ods<10){lcd.print("0");}
    lcd.print(m_zad_ods);
    if(help==1){lcd.setCursor(4,1); lcd.print(">"); }
    if(help==2){lcd.setCursor(10,1); lcd.print("<");}

 if (irrecv.decode(&results)) { 
       kod = results.value;


       if(kod == ok){
            lcd.clear();
            lcd.setCursor(4,0);
            lcd.print("Zapisano!");
            delay(2000);
            m=1;
            czas2 = millis();
        }

if(help == 1){
        if(kod == gora1){
            h_zad_ods++;
            if(h_zad_ods>23){h_zad_ods=0;}
            EEPROM.write(4, h_zad_ods);
            lcd.clear();
        }

            if(kod == dol1){
            h_zad_ods--;
            if(h_zad_ods<0){h_zad_ods=23;}
            EEPROM.write(4, h_zad_ods);
            lcd.clear();
        }
}

if(help == 2){
        if(kod == gora1){
            m_zad_ods++;
            if(m_zad_ods>59){m_zad_ods=0;}
            EEPROM.write(5, m_zad_ods);
            lcd.clear();
        }

            if(kod == dol1){
            m_zad_ods--;
            if(m_zad_ods<0){m_zad_ods=59;}
            EEPROM.write(5, m_zad_ods);
            lcd.clear();
        }
}  

           if(kod == prawo){
            help++;
            if(help>2){help=1;}
            lcd.clear();
       }

           if(kod == lewo){
            help--;
            if(help<1){help=2;}
            lcd.clear();
       }
       irrecv.resume();
       kod="";
 }
  }
  
  void rol_zas(){
    lcd.setCursor(0,0);
    lcd.print("Godz.zasuniecia");
    lcd.setCursor(5,1);
    if(h_zad_zas<10){lcd.print("0");}
    lcd.print(h_zad_zas);
    lcd.print(":");
    if(m_zad_zas<10){lcd.print("0");}
    lcd.print(m_zad_zas);
    if(help==1){lcd.setCursor(4,1); lcd.print(">"); }
    if(help==2){lcd.setCursor(10,1); lcd.print("<");}

 if (irrecv.decode(&results)) { 
       kod = results.value;


       if(kod == ok){
            lcd.clear();
            lcd.setCursor(4,0);
            lcd.print("Zapisano!");
            delay(2000);
            m=1;
            czas2 = millis();
        }

if(help == 1){
        if(kod == gora1){
            h_zad_zas++;
            if(h_zad_zas>23){h_zad_zas=0;}
            EEPROM.write(4, h_zad_zas);
            lcd.clear();
        }

            if(kod == dol1){
            h_zad_zas--;
            if(h_zad_zas<0){h_zad_zas=23;}
            EEPROM.write(4, h_zad_zas);
            lcd.clear();
        }
}

if(help == 2){
        if(kod == gora1){
            m_zad_zas++;
            if(m_zad_zas>59){m_zad_zas=0;}
            EEPROM.write(5, m_zad_zas);
            lcd.clear();
        }

            if(kod == dol1){
            m_zad_zas--;
            if(m_zad_ods<0){m_zad_zas=59;}
            EEPROM.write(5, m_zad_zas);
            lcd.clear();
        }
}  

           if(kod == prawo){
            help++;
            if(help>2){help=1;}
            lcd.clear();
       }

           if(kod == lewo){
            help--;
            if(help<1){help=2;}
            lcd.clear();
       }
       irrecv.resume();
       kod="";
 }
  }
  
  void ust_zegar(){
   lcd.setCursor(1,0);
   lcd.print("Godzina");
   lcd.setCursor(1,1);
   lcd.print("Data");
   if(pom==1){lcd.setCursor(0,0); lcd.print(">");}
   if(pom==2){lcd.setCursor(0,1); lcd.print(">");}

       if (irrecv.decode(&results)) { 
       kod = results.value;


       if(kod == wstecz){m=1; czas2 = millis();}

       if(kod == ok){
            if(pom==1){m=7;}
            if(pom==2){m=8;}
            pom=1;
            lcd.clear();
        }

       if(kod == gora1){
            pom++;
            if(pom>2){pom=1;}
            lcd.clear();
       }

           if(kod == dol1){
            pom--;
            if(pom<1){pom=2;}
            lcd.clear();
       }
       irrecv.resume();
       kod="";
    }
    }
    
    void ust_czas(){
      lcd.setCursor(0,0);
      lcd.print("Ustaw czas");
      lcd.setCursor(5,1);
      if(godzina<10){lcd.print("0");}
       lcd.print(godzina);
       lcd.print(":");
       if(minuta<10){lcd.print("0");}
       lcd.print(minuta);
       if(help==1){lcd.setCursor(4,1); lcd.print(">"); }
       if(help==2){lcd.setCursor(10,1); lcd.print("<");}

        if (irrecv.decode(&results)) { 
       kod = results.value;


       if(kod == ok){
            rtc.adjust(DateTime(rok, miesiac, dzien, godzina, minuta, sekunda));
            lcd.clear();
            lcd.setCursor(4,0);
            lcd.print("Zapisano!");
            delay(2000);
            m=1;
            zi=0;
            czas2 = millis();
        }

if(help == 1){
        if(kod == gora1){
            godzina++;
            if(godzina>23){godzina=0;}
            lcd.clear();
        }

            if(kod == dol1){
            godzina--;
            if(godzina<0){godzina=23;}
            lcd.clear();
        }
}

if(help == 2){
        if(kod == gora1){
            minuta++;
            if(minuta>59){minuta=0;}
            lcd.clear();
        }

            if(kod == dol1){
            minuta--;
            if(minuta<0){minuta=59;}
            lcd.clear();
        }
}  

           if(kod == prawo){
            help++;
            if(help>2){help=1;}
            lcd.clear();
       }

           if(kod == lewo){
            help--;
            if(help<1){help=2;}
            lcd.clear();
       }
       irrecv.resume();
       kod="";
 }
    } 
  
  void ust_data(){
      lcd.setCursor(0,0);
      lcd.print("Ustaw date");
      lcd.setCursor(3,1);
       if(dzien < 10){lcd.print("0");}
       lcd.print(dzien);
       if(help != 2){lcd.print("/");}
       if(help == 2){lcd.print(">");}
       if(miesiac < 10){lcd.print("0");}
       lcd.print(miesiac);
       lcd.print("/");
       lcd.print(rok);
       if(help==1){lcd.setCursor(2,1); lcd.print(">"); }
       if(help==3){lcd.setCursor(13,1); lcd.print("<");}

       if (irrecv.decode(&results)) { 
       kod = results.value;


       if(kod == ok){
            rtc.adjust(DateTime(rok, miesiac, dzien, godzina, minuta, sekunda));
            lcd.clear();
            lcd.setCursor(4,0);
            lcd.print("Zapisano!");
            delay(2000);
            m=1;
            zi=0;
            czas2 = millis();
        }

if(help == 1){
        if(kod == gora1){
            dzien++;
            if(dzien>31){dzien=1;}
            lcd.clear();
        }

            if(kod == dol1){
            dzien--;
            if(dzien<1){dzien=31;}
            lcd.clear();
        }
}

if(help == 2){
        if(kod == gora1){
            miesiac++;
            if(miesiac>12){miesiac=1;}
            lcd.clear();
        }

            if(kod == dol1){
            miesiac--;
            if(miesiac<1){miesiac=12;}
            lcd.clear();
        }
}  

if(help == 3){
        if(kod == gora1){
             rok++;
            lcd.clear();
        }

            if(kod == dol1){
             rok--;
            lcd.clear();
        }
}  

           if(kod == prawo){
            help++;
            if(help>3){help=1;}
            lcd.clear();
       }

           if(kod == lewo){
            help--;
            if(help<1){help=3;}
            lcd.clear();
       }
       irrecv.resume();
       kod="";
 }
    }  

void czas(){
       DateTime now = rtc.now();
     a=now.hour();
     b=now.minute();
     c=now.second();
     d=now.day();
     e=now.month();
     f=now.year();
     
     
     if(e<3)
     {
      z = f - 1;
      k = 0;
     }
     
     if(e>=3)
     {
        z = f;
        k = 2;
     }
     
     dzien_tyg_1=(23*e/9)+d+4+f+(z/4)-(z/100)+(z/400)-k;
     dzien_tyg = dzien_tyg_1 % 7;
}

  void sterowanie_silnikami(){

    
         if(dzien_tyg==1 || dzien_tyg==2 || dzien_tyg==3 || dzien_tyg==4 || dzien_tyg==5)
     {
     if(h_zad_ods == a && m_zad_ods == b && c==0)
    {
     r1=1;
     expander.digitalWrite(6,HIGH); 
     expander.digitalWrite(7,LOW);
    }
    
    if(h_zad_ods == a && m_zad_ods == b && c==0)
    {
      r2=1;
     expander.digitalWrite(4,HIGH); 
     expander.digitalWrite(5,LOW); 
    }
    
     }
     if(dzien_tyg==0 || dzien_tyg==6)
     {
     if(h_zad_ods_w == a && m_zad_ods_w == b && c==0)
    {
     r1=1;
     expander.digitalWrite(6,HIGH); 
     expander.digitalWrite(7,LOW);
    }
    
    if(h_zad_ods_w == a && m_zad_ods_w == b && c==0)
    {
      r2=1;
     expander.digitalWrite(4,HIGH); 
     expander.digitalWrite(5,LOW); 
    }
     }   
    
     if(h_zad_zas == a && m_zad_zas == b && c==0)
    {
      r1=2;
     expander.digitalWrite(6,LOW); 
     expander.digitalWrite(7,HIGH);
    }
    
    
    if(h_zad_zas == a && m_zad_zas == b && c==0)
    {
      r2=2;
     expander.digitalWrite(4,LOW); 
     expander.digitalWrite(5,HIGH); 
    }
    
    if (r1==1 && expander.digitalRead(1) == LOW)
    {
     expander.digitalWrite(6,LOW); 
     expander.digitalWrite(7,LOW);
     r1=0;
    }
    
    if (r2==1 && expander.digitalRead(3) == LOW)
    {
     expander.digitalWrite(4,LOW); 
     expander.digitalWrite(5,LOW);
     r2=0;
    }
    
  if (r1==2 && expander.digitalRead(0) == LOW)
    {
     expander.digitalWrite(6,LOW); 
     expander.digitalWrite(7,LOW);
     r1=0;
    }
    
     if (r2==2 && expander.digitalRead(2) == LOW)
    {
     expander.digitalWrite(4,LOW); 
     expander.digitalWrite(5,LOW);
     r2=0;
    }
  }

  
  void loop() {
    
     czas();
     sterowanie_silnikami();    
    
    if(m==1){glowna();}
    if(m==2){menu(); digitalWrite(podswietlanie, HIGH);}
    if(m==3){ust_rol(); digitalWrite(podswietlanie, HIGH);}
    if(m==4){ust_zegar(); digitalWrite(podswietlanie, HIGH);}
    if(m==5){rol_ods(); digitalWrite(podswietlanie, HIGH);}
    if(m==6){rol_zas(); digitalWrite(podswietlanie, HIGH);}
    if(m==7){ust_czas(); digitalWrite(podswietlanie, HIGH);}
    if(m==8){ust_data(); digitalWrite(podswietlanie, HIGH);}
    if(m==9){ust_tydz(); digitalWrite(podswietlanie, HIGH);}
    if(m==10){rol_ods_w(); digitalWrite(podswietlanie, HIGH);}
    if(m==11){kody1();}
    if(m==12){kody2();}
    if(m==13){kody3();}
    if(m==14){kody4();}
    if(m==15){kody5();}
    if(m==16){kody6();}
   
}
